<template>
  <div class="balance-page">
    <div class="wrapper-content">
      <div class="content-top">
        <div class="title-page">
          {{ $t('balances.title')}}
        </div>
        <div class="balance__estimated">
          <span class="estimated__text">{{ $t('balances.estimated')}}</span>
          <span class="estimated__number">{{ totalUsdValue | formatCurrencyAmount('usd', '0') }} USD</span>
          <span class="estimated__number">{{ totalHetaTokensValue | formatCurrencyAmount('heta', '0') }} HETA Tokens</span>
        </div>
      </div>

      <data-table :getData="getData"
                  class="balance-table"
                  ref="datatable">
        <th class="pointer" data-sort-field="currency">
          {{ $t('balances.coin')}}
        </th>
        <th>{{ $t('balances.name')}}</th>
        <th class="text-right">{{ $t('balances.balance')}}</th>
        <th class="pointer text-right" data-sort-field="usd_value">{{ $t('balances.usd.value')}}</th>
        <th class="pointer text-right" data-sort-field="heta_value">{{ $t('balances.heta.value')}}</th>
        <th></th>
        <template slot="body" slot-scope="props">
          <tr>
            <td class="coin">
              <img :src="`/images/icon/balanceImg/heta-${props.item.currency}-icon.png`"
                   :alt="props.item.currency" class="coin__image">
              <span class="coin__name">{{ props.item.currency | uppercase}}</span>
            </td>
            <td class="name">{{ getCoinFullName(props.item.currency) }}</td>
            <td class="balance text-right">{{  props.item.balance | formatCurrencyAmount(props.item.currency, '0') }}</td>
            <td class="usd-value text-right">
              {{ props.item.usd_value | formatCurrencyAmount('usd', '0') }}
            </td>
            <td class="usd-value text-right">
              {{ props.item.heta_value | formatCurrencyAmount('heta', '0') }}
            </td>
            <td>
              <router-link v-if="props.item.currency === 'heta'" :to="{ path: 'dashboard', query: { currency: 'btc' } }">
                <span class="deposit-btn">{{ $t('balances.buy')}}</span>
              </router-link>
              <router-link v-else :to="{ path: 'deposit', query: { currency: props.item.currency } }">
                <span class="deposit-btn">{{ $t('balances.deposit')}}</span>
              </router-link>
            </td>
          </tr>
        </template>
      </data-table>
    </div>
  </div>
</template>
<script>
  import { mapState, mapGetters } from 'vuex';
  import BigNumber from 'bignumber.js';
  import DataTable from '../components/DataTable.vue';

  export default {
    components: {
      DataTable
    },
    data() {
      return {
        coins: {
          btc : {
            name: 'BTC',
            fullname: 'Bitcoin',
          },
          eth : {
            name: 'ETH',
            fullname: 'Ethereum',
          },
          usdt : {
            name: 'USDT',
            fullname: 'Tether USDT',
          },
          heta : {
            name: 'HETA',
            fullname: 'Heta Token',
          }
        }
      }
    },
    watch: {
      wallets() {
        this.refreshDataTable();
      },
      prices() {
        this.refreshDataTable();
      },
    },
    computed: {
      totalUsdValue() {
        return this.getEstimateTotalValue('usd');
      },
      totalHetaTokensValue() {
        return this.getEstimateTotalValue('heta');
      },
      ...mapState(['wallets', 'prices']),
      ...mapGetters(['getPrecision']),
    },
    methods: {
      getCoinFullName(coin) {
        if (!this.coins[coin]) {
          return '';
        }
        return this.coins[coin].fullname;
      },

      getEstimateTotalValue(currency) {
        let total = BigNumber('0');
        _.forEach(this.wallets, wallet => {
          if (BigNumber(wallet.balance).comparedTo(0) > 0) {
            let est = BigNumber(this.getEstimateValue(wallet.balance, wallet.currency, currency)).toFixed(this.getPrecision(currency), BigNumber.ROUND_DOWN);
            total = total.plus(est);
          }
        });

        return total.toString();
      },

      getEstimateValue(amount, coin, currency) {
        if (currency === 'usd') {
          return BigNumber(`${amount}`).multipliedBy(this.getRate(coin, currency)).toString();
        }

        const rate = BigNumber(this.getRate(currency, coin)).toFixed(this.getPrecision(coin), BigNumber.ROUND_UP);
        return BigNumber(`${amount}`).div(rate).toString();
      },

      getRate (coin, currency) {
        if (currency === 'usd') {
          return this.getPrice(coin);
        }

        if (BigNumber(this.getPrice(currency)).isZero()) {
          return '0';
        }

        return BigNumber(this.getPrice(coin)).div(this.getPrice(currency)).toString()
      },

      getPrice (coin) {
        if (!this.prices[coin]) {
          return '0';
        }

        return `${this.prices[coin] || 0}`;
      },

      toNumber(amount, round = 10) {
        const newAmount =  BigNumber(`${amount}`).toFixed(round);
        return BigNumber(`${newAmount}`).toNumber();
      },

      refreshDataTable() {
        _.forEach(this.wallets, wallet => {
          wallet.usd_value = this.toNumber(this.getEstimateValue(wallet.balance, wallet.currency, 'usd'));
          wallet.heta_value = this.toNumber(this.getEstimateValue(wallet.balance, wallet.currency, 'heta'));
        });
        this.$refs.datatable.refresh();
      },

      getData(params){
        return new Promise((resolve) => {
          const dataPerPage = this.getDataPerPage(params);
          return resolve({
            data: dataPerPage.data,
            meta: {
              current_page: params.page,
              total: dataPerPage.total,
              last_page: dataPerPage.last_page,
              per_page: params.limit,
            } });
        });
      },

      getDataPerPage(params) {
        // filter wallets by input search
        let wallets = _.values(this.wallets);

        if (params.sortField && params.sortDirection) {
          wallets = _.orderBy(wallets, params.sortField, params.sortDirection);
        }

        // calculate paginate
        const total = wallets.length;

        let lastPage = total/params.limit;
        if (total % params.limit !== 0) {
          lastPage++;
        }
        // reset current page = 1
        if (params.page > parseInt(lastPage)) {
          params.page = 1;
        }
        const dataPerPage = _.slice(wallets, (params.page - 1) * params.limit, params.page * params.limit);
        return {
          total: total,
          last_page: parseInt(lastPage),
          data: dataPerPage
        }
      },
    },
    mounted() {
      this.$nextTick(() => {
        this.refreshDataTable();
      })
    }
  }
</script>

<style scoped lang="scss">
  @import '../../../sass/_variables.scss';
  * {
    font-family: $font-family-home;
  }

  @each $width in ( 15, 20 ) {
    .w-#{$width} {
      width: $width * 1% !important;
    }
  }

  .balance-page {
    padding: 56px 0 80px;
    min-height: calc(100vh - 165px);
  }

  .content-top {
    font-size: 0;
    margin-bottom: 15px;
  }

  .title-page {
    font-size: $big;
    font-weight: bold;
    color: $black;
    display: inline-block;
    width: 30%;
  }

  .balance__estimated {
    display: inline-block;
    width: 70%;
    text-align: right;
    .estimated__text {
      font-size: $small;
      font-weight: 300;
      color: $gray;
    }

    .estimated__number {
      font-size: $medium;
      font-weight: bold;
      color: #000;
      padding-right: 9px;

      &:not(:first-child) {
        padding-left: 5px;
      }

      &:not(:last-child) {
        border-right: 1px solid #b0b0b0;
      }
    }
  }

  .balance-table {
    width: 100%;
    position: relative;

    &:before {
      content: '';
      display: block;
      position: absolute;
      top: 0;
      left: 0;
      height: 50px;
      width: 100%;
      border-radius: 30px;
      background-color: #efefef;
      z-index: -1;
    }

    thead {
      position: relative;

      tr th {
        padding: 14px 35px;
        font-weight: 500;
        font-size: $small;
        color: #505050;
        width: 20%;
        position: relative;
        cursor: default;
        text-transform: capitalize;
      }
      th[data-sort-order='desc']::after {
        content: '';
        display: inline-block !important;
        width: 14px;
        height: 14px;
        background-size: cover;
        position: relative !important;
        background-image: url(/images/icon/arrow-top.png);
        top: 2px;
      }
      th[data-sort-order='asc']::after {
        content: '';
        display: inline-block !important;
        width: 14px;
        height: 14px;
        background-size: cover;
        position: relative !important;
        background-image: url(/images/icon/arrow-top.png);
        top: 2px;
        transform: rotate(180deg);
      }
    }

    tbody {
      tr {
        border-bottom: 1px solid #e0e0e0;
        td {
          padding: 10px 35px;

          &:last-child {
            text-align: right;
          }
        }
      }
    }

    .coin {
      .coin__image {
        margin-right: 10px;
        width: 20px;
        height: 20px;      }

      .coin__name {
        font-size: $small;
        font-weight: bold;
        color: $black;
      }
    }

    .name {
      text-transform: capitalize;
    }

    .name,
    .balance,
    .usd-value {
      font-size: $small;
      font-weight: bold;
      color: #1c1c1c;
    }
  }

  .deposit-btn {
    display: inline-block;
    text-transform: uppercase;
    width: 106px;
    height: 32px;
    font-size: 12px;
    font-weight: bold;
    line-height: 2.5;
    letter-spacing: 0.5px;
    text-align: center;
    color: #fa7300;
    border-radius: 30px;
    cursor: pointer;
    transition: all 0.3s ease-in-out;
    border: solid 1px #fa7300;
    background: transparent;
    &.active,
    &:hover {
      background-color: #fa7300;
      color: $white;
    }
  }

  .arrow-top {
    height: 14px;
    margin-top: -3px;
  }

  .pointer {
    cursor: pointer !important;
  }

  @media screen and (max-width: 1200px) {
    .balance-page {
      padding: 56px 20px 80px;
      min-height: calc(100vh - 165px);
    }
    .balance-table {
      thead tr th {
        padding: 14px 10px;
      }

      tbody tr td {
        padding: 10px;
      }
    }
  }
</style>
